
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef scout_POSTER_LIB_H
#define scout_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "scoutType.h"
#include "scoutError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[SCOUT_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} SCOUT_CNTRL_STR;

/* For consistency with other posters */
typedef SCOUT_CNTRL_STR SCOUT_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "scoutPosterLibStruct.h"



/* Posters */
#define SCOUT_CNTRL_POSTER_NAME genomInstanceSuffixName("scout", "Cntrl")
#define SCOUT_ROBOT_POSTER_NAME genomInstanceSuffixName("scout", "Robot")
#define SCOUT_BUMPER_POSTER_NAME genomInstanceSuffixName("scout", "Bumper")
#define SCOUT_SONARS_POSTER_NAME genomInstanceSuffixName("scout", "Sonars")
#define SCOUT_SENSORSCONFIG_POSTER_NAME genomInstanceSuffixName("scout", "SensorsConfig")
#define SCOUT_REFERENCES_POSTER_NAME genomInstanceSuffixName("scout", "References")
#define SCOUT_STATE_POSTER_NAME genomInstanceSuffixName("scout", "State")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS scoutPosterInit ( void );
extern POSTER_ID scoutCntrlPosterID ();
extern STATUS scoutCntrlPosterRead ( SCOUT_CNTRL_STR *scoutCntrlStrId );
extern STATUS scoutCntrlPosterInit ( void );
extern STATUS scoutCntrlInstancePosterRead(const char *name, SCOUT_CNTRL_STR *scoutCntrlStrId);
extern STATUS scoutRobotPosterInit ( void );
extern POSTER_ID scoutRobotPosterID ( void );
extern STATUS scoutRobotPosterRead ( SCOUT_ROBOT_POSTER_STR *x );
extern STATUS scoutRobotInstancePosterRead ( const char *, SCOUT_ROBOT_POSTER_STR * );
extern STATUS scoutRobotPositionPosterRead ( SCOUT_POS_STR *Position );
extern STATUS scoutRobotPositionInstancePosterRead( const char *, SCOUT_POS_STR * );
extern STATUS scoutRobotPosErrorPosterRead ( SCOUT_ODO_VAR_STR *PosError );
extern STATUS scoutRobotPosErrorInstancePosterRead( const char *, SCOUT_ODO_VAR_STR * );
extern STATUS scoutBumperPosterInit ( void );
extern POSTER_ID scoutBumperPosterID ( void );
extern STATUS scoutBumperPosterRead ( SCOUT_BUMPER_POSTER_STR *x );
extern STATUS scoutBumperInstancePosterRead ( const char *, SCOUT_BUMPER_POSTER_STR * );
extern STATUS scoutBumperbumperPosterRead ( SCOUT_BUMBERS_STATE *bumper );
extern STATUS scoutBumperbumperInstancePosterRead( const char *, SCOUT_BUMBERS_STATE * );
extern STATUS scoutSonarsPosterInit ( void );
extern POSTER_ID scoutSonarsPosterID ( void );
extern STATUS scoutSonarsPosterRead ( SCOUT_SONARS_POSTER_STR *x );
extern STATUS scoutSonarsInstancePosterRead ( const char *, SCOUT_SONARS_POSTER_STR * );
extern STATUS scoutSonarssonarsEchoPosterRead ( SCOUT_SONARS_ECHO_RHO *sonarsEcho );
extern STATUS scoutSonarssonarsEchoInstancePosterRead( const char *, SCOUT_SONARS_ECHO_RHO * );
extern STATUS scoutSonarssonarsEchoFrameRobotPosterRead ( SCOUT_SONARS_ECHO_XY *sonarsEchoFrameRobot );
extern STATUS scoutSonarssonarsEchoFrameRobotInstancePosterRead( const char *, SCOUT_SONARS_ECHO_XY * );
extern STATUS scoutSonarssonarsEchoFrameGlobalPosterRead ( SCOUT_SONARS_ECHO_XY *sonarsEchoFrameGlobal );
extern STATUS scoutSonarssonarsEchoFrameGlobalInstancePosterRead( const char *, SCOUT_SONARS_ECHO_XY * );
extern STATUS scoutSensorsConfigPosterInit ( void );
extern POSTER_ID scoutSensorsConfigPosterID ( void );
extern STATUS scoutSensorsConfigPosterRead ( SCOUT_SENSORSCONFIG_POSTER_STR *x );
extern STATUS scoutSensorsConfigInstancePosterRead ( const char *, SCOUT_SENSORSCONFIG_POSTER_STR * );
extern STATUS scoutSensorsConfigsonarsCoordPosterRead ( SCOUT_SONARS_CONFIG *sonarsCoord );
extern STATUS scoutSensorsConfigsonarsCoordInstancePosterRead( const char *, SCOUT_SONARS_CONFIG * );
extern STATUS scoutSensorsConfigbumpersPosPosterRead ( SCOUT_BUMPERS_POS *bumpersPos );
extern STATUS scoutSensorsConfigbumpersPosInstancePosterRead( const char *, SCOUT_BUMPERS_POS * );
extern STATUS scoutReferencesPosterInit ( void );
extern POSTER_ID scoutReferencesPosterID ( void );
extern STATUS scoutReferencesPosterRead ( SCOUT_REFERENCES_POSTER_STR *x );
extern STATUS scoutReferencesInstancePosterRead ( const char *, SCOUT_REFERENCES_POSTER_STR * );
extern STATUS scoutReferencesrefPosterRead ( SCOUT_REF_STR *ref );
extern STATUS scoutReferencesrefInstancePosterRead( const char *, SCOUT_REF_STR * );
extern STATUS scoutReferencesspeedRefPosterRead ( SCOUT_SPEED_REF_STR *speedRef );
extern STATUS scoutReferencesspeedRefInstancePosterRead( const char *, SCOUT_SPEED_REF_STR * );
extern STATUS scoutStatePosterInit ( void );
extern POSTER_ID scoutStatePosterID ( void );
extern STATUS scoutStatePosterRead ( SCOUT_STATE_POSTER_STR *x );
extern STATUS scoutStateInstancePosterRead ( const char *, SCOUT_STATE_POSTER_STR * );
extern STATUS scoutStatealarmPosterRead ( SCOUT_ALARMS *alarm );
extern STATUS scoutStatealarmInstancePosterRead( const char *, SCOUT_ALARMS * );
extern STATUS scoutStatebatteriesPosterRead ( SCOUT_BATTERIES_STR *batteries );
extern STATUS scoutStatebatteriesInstancePosterRead( const char *, SCOUT_BATTERIES_STR * );
#ifdef __cplusplus
}
#endif
#endif

