
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef scout_TCLSERV_CLIENT_ERROR_H
#define scout_TCLSERV_CLIENT_ERROR_H

#include <server/scoutError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum scout_error {
	E_scout_OK					  			= 0,

	/* module errors */
	E_scout_BAD_CMD_DATA                   = S_scout_BAD_CMD_DATA,
	E_scout_POSTER_NOT_UPDATED             = S_scout_POSTER_NOT_UPDATED,
	E_scout_CMD_STOP_TRACK                 = S_scout_CMD_STOP_TRACK,
	E_scout_BAD_REF                        = S_scout_BAD_REF,
	E_scout_POSTER_NOT_FOUND               = S_scout_POSTER_NOT_FOUND,
	E_scout_BAD_REF_DATA                   = S_scout_BAD_REF_DATA,
	E_scout_TRACKING_ON                    = S_scout_TRACKING_ON,
	E_scout_UNINITIALIZED                  = S_scout_UNINITIALIZED,
	E_scout_UNKNOWN_ERROR                  = S_scout_UNKNOWN_ERROR,
	E_scout_OUT_OF_MEMORY                  = S_scout_OUT_OF_MEMORY,
	E_scout_CONNECTION_FAILED              = S_scout_CONNECTION_FAILED,
	E_scout_ROBOT_NOT_FOUND                = S_scout_ROBOT_NOT_FOUND,
	E_scout_UNKNOWN_ALARM                  = S_scout_UNKNOWN_ALARM,
	E_scout_NO_MOTION                      = S_scout_NO_MOTION,
	E_scout_REF_NOT_UPDATED                = S_scout_REF_NOT_UPDATED,
	E_scout_IMPORTANT_DRIFT                = S_scout_IMPORTANT_DRIFT,
	E_scout_LOW_BATTERY                    = S_scout_LOW_BATTERY,
	E_scout_CHOC_BUMPER                    = S_scout_CHOC_BUMPER,
	E_scout_MOTION_ERROR                   = S_scout_MOTION_ERROR,
	E_scout_ESTOP_DOWN                     = S_scout_ESTOP_DOWN,
	E_scout_JOYSTICK_IN_USE                = S_scout_JOYSTICK_IN_USE,
	E_scout_INVALID_ARGUMENT               = S_scout_INVALID_ARGUMENT,
	E_scout_UNKNOWN_AXIS_STATUS            = S_scout_UNKNOWN_AXIS_STATUS,


	/* std errors */
	E_scout_ACTIVITY_INTERRUPTED           = S_scout_stdGenoM_ACTIVITY_INTERRUPTED,
	E_scout_TOO_MANY_ACTIVITIES            = S_scout_stdGenoM_TOO_MANY_ACTIVITIES,
	E_scout_ACTIVITY_FAILED                = S_scout_stdGenoM_ACTIVITY_FAILED,
	E_scout_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_scout_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_scout_UNKNOWN_ACTIVITY               = S_scout_stdGenoM_UNKNOWN_ACTIVITY,
	E_scout_FORBIDDEN_ACTIVITY_TRANSITION  = S_scout_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_scout_SYSTEM_ERROR                   = S_scout_stdGenoM_SYSTEM_ERROR,
	E_scout_ACTIVITY_ALREADY_ENDED         = S_scout_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_scout_WAIT_INIT_RQST                 = S_scout_stdGenoM_WAIT_INIT_RQST,
	E_scout_CONTROL_CODEL_ERROR            = S_scout_stdGenoM_CONTROL_CODEL_ERROR,
	E_scout_EXEC_TASK_SUSPENDED            = S_scout_stdGenoM_EXEC_TASK_SUSPENDED,
	E_scout_BAD_BLOCK_TYPE                 = S_scout_stdGenoM_BAD_BLOCK_TYPE,
	E_scout_BAD_POSTER_TYPE                = S_scout_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum scout_error scout_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int scout_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the scout context.
 *
 * Returns NULL in case of failure
 */
const char* scout_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
