
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef scout_TCLSERV_CLIENT_MSG_LIB_H
#define scout_TCLSERV_CLIENT_MSG_LIB_H

#include <server/scoutType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int scoutTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int scoutTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int scoutTclservClientConnectRobotRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SCOUT_CONNECT_PARAM *(in_connectParam) 
		);

int scoutTclservClientConnectRobotReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientConnectRobotRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SCOUT_CONNECT_PARAM *(in_connectParam) ,
				
				int *bilan);

int scoutTclservClientConnectRobotRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SCOUT_CONNECT_PARAM *(in_connectParam) ,
					
					int *bilan);




int scoutTclservClientGetConnectParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int scoutTclservClientGetConnectParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       SCOUT_CONNECT_PARAM *(out_connectParam),
			       int *bilan);

int scoutTclservClientGetConnectParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 SCOUT_CONNECT_PARAM *(out_connectParam),
				 int *bilan);




int scoutTclservClientDisconnectRobotRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int scoutTclservClientDisconnectRobotReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientDisconnectRobotRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int scoutTclservClientDisconnectRobotRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int scoutTclservClientSetPosRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SCOUT_SET_POS_STR *(in_setPos) 
		);

int scoutTclservClientSetPosReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientSetPosRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SCOUT_SET_POS_STR *(in_setPos) ,
				
				int *bilan);

int scoutTclservClientSetPosRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SCOUT_SET_POS_STR *(in_setPos) ,
					
					int *bilan);




int scoutTclservClientGetPosRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int scoutTclservClientGetPosReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       SCOUT_SET_POS_STR *(out_setPos),
			       int *bilan);

int scoutTclservClientGetPosRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 SCOUT_SET_POS_STR *(out_setPos),
				 int *bilan);




int scoutTclservClientSetPosDevRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 SCOUT_ODO_VAR_STR *(in_odoError)
		);

int scoutTclservClientSetPosDevReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int scoutTclservClientSetPosDevRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 SCOUT_ODO_VAR_STR *(in_odoError) ,
				 
				 int *bilan);




int scoutTclservClientStopRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int scoutTclservClientStopReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientStopRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int scoutTclservClientStopRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int scoutTclservClientTurnRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SCOUT_TURN *(in_turn) 
		);

int scoutTclservClientTurnReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientTurnRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SCOUT_TURN *(in_turn) ,
				
				int *bilan);

int scoutTclservClientTurnRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SCOUT_TURN *(in_turn) ,
					
					int *bilan);




int scoutTclservClientGoToRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SCOUT_REF_STR *(in_ref) 
		);

int scoutTclservClientGoToReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientGoToRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SCOUT_REF_STR *(in_ref) ,
				
				int *bilan);

int scoutTclservClientGoToRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SCOUT_REF_STR *(in_ref) ,
					
					int *bilan);




int scoutTclservClientGoToSpeedRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SCOUT_SPEED_REF_STR *(in_speedRef) 
		);

int scoutTclservClientGoToSpeedReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientGoToSpeedRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SCOUT_SPEED_REF_STR *(in_speedRef) ,
				
				int *bilan);

int scoutTclservClientGoToSpeedRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SCOUT_SPEED_REF_STR *(in_speedRef) ,
					
					int *bilan);




int scoutTclservClientTrackStartRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SCOUT_POSTER_NAME *(in_posterName) 
		);

int scoutTclservClientTrackStartReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientTrackStartRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SCOUT_POSTER_NAME *(in_posterName) ,
				
				int *bilan);

int scoutTclservClientTrackStartRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SCOUT_POSTER_NAME *(in_posterName) ,
					
					int *bilan);




int scoutTclservClientTrackSpeedStartRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SCOUT_POSTER_NAME *(in_posterName) 
		);

int scoutTclservClientTrackSpeedStartReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientTrackSpeedStartRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SCOUT_POSTER_NAME *(in_posterName) ,
				
				int *bilan);

int scoutTclservClientTrackSpeedStartRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SCOUT_POSTER_NAME *(in_posterName) ,
					
					int *bilan);




int scoutTclservClientTrackConfigStartRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 SCOUT_POSTER_NAME *(in_posterName) 
		);

int scoutTclservClientTrackConfigStartReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientTrackConfigStartRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				SCOUT_POSTER_NAME *(in_posterName) ,
				
				int *bilan);

int scoutTclservClientTrackConfigStartRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					SCOUT_POSTER_NAME *(in_posterName) ,
					
					int *bilan);




int scoutTclservClientTrackEndRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int scoutTclservClientTrackEndReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int scoutTclservClientTrackEndRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int scoutTclservClientSonarsOnRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int scoutTclservClientSonarsOnReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientSonarsOnRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int scoutTclservClientSonarsOnRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int scoutTclservClientSonarsOffRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int scoutTclservClientSonarsOffReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int scoutTclservClientSonarsOffRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int scoutTclservClientSonarsOffRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int scoutTclservClientSetSonarsFiringOrderRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 SCOUT_SONARS_FIRING_ORDER *(in_sonarsFiring)
		);

int scoutTclservClientSetSonarsFiringOrderReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int scoutTclservClientSetSonarsFiringOrderRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 SCOUT_SONARS_FIRING_ORDER *(in_sonarsFiring) ,
				 
				 int *bilan);




int scoutTclservClientGetSonarsFiringOrderRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int scoutTclservClientGetSonarsFiringOrderReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       SCOUT_SONARS_FIRING_ORDER *(out_sonarsFiring),
			       int *bilan);

int scoutTclservClientGetSonarsFiringOrderRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 SCOUT_SONARS_FIRING_ORDER *(out_sonarsFiring),
				 int *bilan);




int scoutTclservClientSetCmdDistRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 double *(in_distPoint)
		);

int scoutTclservClientSetCmdDistReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int scoutTclservClientSetCmdDistRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 double *(in_distPoint) ,
				 
				 int *bilan);




int scoutTclservClientGetCmdDistRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int scoutTclservClientGetCmdDistReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       double *(out_distPoint),
			       int *bilan);

int scoutTclservClientGetCmdDistRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 double *(out_distPoint),
				 int *bilan);




int scoutTclservClientGetCmdConfigRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int scoutTclservClientGetCmdConfigReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       SCOUT_CMD_PARAM_STR *(out_cmd),
			       int *bilan);

int scoutTclservClientGetCmdConfigRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 SCOUT_CMD_PARAM_STR *(out_cmd),
				 int *bilan);




int scoutTclservClientSetCmdConfigRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 SCOUT_CMD_PARAM_STR *(in_cmd)
		);

int scoutTclservClientSetCmdConfigReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int scoutTclservClientSetCmdConfigRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 SCOUT_CMD_PARAM_STR *(in_cmd) ,
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* scoutTCLSERV_CLIENT_MSG_LIB_H */

