
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] scoutInstall] >= 0 } {
    interp expose {} scoutInstall
}

proc ::scoutInstall { name } {
    foreach rqst { "ConnectRobot" "GetConnectParams" "DisconnectRobot" "SetPos" "GetPos" "SetPosDev" "Stop" "Turn" "GoTo" "GoToSpeed" "TrackStart" "TrackSpeedStart" "TrackConfigStart" "TrackEnd" "SonarsOn" "SonarsOff" "SetSonarsFiringOrder" "GetSonarsFiringOrder" "SetCmdDist" "GetCmdDist" "GetCmdConfig" "SetCmdConfig" "RobotPositionPosterRead" "RobotPosErrorPosterRead" "BumperbumperPosterRead" "SonarssonarsEchoPosterRead" "SonarssonarsEchoFrameRobotPosterRead" "SonarssonarsEchoFrameGlobalPosterRead" "SensorsConfigsonarsCoordPosterRead" "SensorsConfigbumpersPosPosterRead" "ReferencesrefPosterRead" "ReferencesspeedRefPosterRead" "StatealarmPosterRead" "StatebatteriesPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} scout$rqst $name
    }
}

interp hide {} scoutInstall




# ConnectRobot ----------------------------------------------------------

if { [lsearch [interp hidden] scoutConnectRobot] >= 0 } {
    interp expose {} scoutConnectRobot
}
if { [lsearch [interp hidden] scoutConnectRobotFormatOutput] >= 0 } {
    interp expose {} scoutConnectRobotFormatOutput
}

proc ::scoutConnectRobot { name args } {
    set format {}
    lappend format [list { "SCOUT_NCLIENTSIMUL_CONNECTION" "SCOUT_NCLIENT_CONNECTION" "SCOUT_NDIRECT_CONNECTION" "SCOUT_NOT_CONNECTED" } "connectParam.connectMode" "" ]
    lappend format [list string "connectParam.host" "" ]
    lappend format [list int "connectParam.port" 0 ]
    lappend format [list int "connectParam.robotId" 0 ]

    return [ ::cs::rqstSend "${name}" "ConnectRobot" \
	"** undocumented **" \
	"SCOUT_CONNECT_PARAM\n| SCOUT_CONNECT_MODE connectMode\n| char host\[16\]\n| int port\n| int robotId\n" \
	4 \
	$format \
	$args ]
}


proc ::scoutConnectRobotFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutConnectRobot
interp hide {} scoutConnectRobotFormatOutput





# GetConnectParams ----------------------------------------------------------

if { [lsearch [interp hidden] scoutGetConnectParams] >= 0 } {
    interp expose {} scoutGetConnectParams
}
if { [lsearch [interp hidden] scoutGetConnectParamsFormatOutput] >= 0 } {
    interp expose {} scoutGetConnectParamsFormatOutput
}

proc ::scoutGetConnectParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetConnectParams" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::scoutGetConnectParamsFormatOutput { list } {
    set format { {} status { } { connectParam { } connectMode { } host { } port { } robotId } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutGetConnectParams
interp hide {} scoutGetConnectParamsFormatOutput





# DisconnectRobot ----------------------------------------------------------

if { [lsearch [interp hidden] scoutDisconnectRobot] >= 0 } {
    interp expose {} scoutDisconnectRobot
}
if { [lsearch [interp hidden] scoutDisconnectRobotFormatOutput] >= 0 } {
    interp expose {} scoutDisconnectRobotFormatOutput
}

proc ::scoutDisconnectRobot { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "DisconnectRobot" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::scoutDisconnectRobotFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutDisconnectRobot
interp hide {} scoutDisconnectRobotFormatOutput





# SetPos ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSetPos] >= 0 } {
    interp expose {} scoutSetPos
}
if { [lsearch [interp hidden] scoutSetPosFormatOutput] >= 0 } {
    interp expose {} scoutSetPosFormatOutput
}

proc ::scoutSetPos { name args } {
    set format {}
    lappend format [list double "setPos.x" 0.0 ]
    lappend format [list double "setPos.y" 0.0 ]
    lappend format [list double "setPos.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetPos" \
	"** undocumented **" \
	"SCOUT_SET_POS_STR\n| double x\n| double y\n| double theta\n" \
	3 \
	$format \
	$args ]
}


proc ::scoutSetPosFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSetPos
interp hide {} scoutSetPosFormatOutput





# GetPos ----------------------------------------------------------

if { [lsearch [interp hidden] scoutGetPos] >= 0 } {
    interp expose {} scoutGetPos
}
if { [lsearch [interp hidden] scoutGetPosFormatOutput] >= 0 } {
    interp expose {} scoutGetPosFormatOutput
}

proc ::scoutGetPos { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetPos" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::scoutGetPosFormatOutput { list } {
    set format { {} status { } { setPos { } x { } y { } theta } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutGetPos
interp hide {} scoutGetPosFormatOutput





# SetPosDev ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSetPosDev] >= 0 } {
    interp expose {} scoutSetPosDev
}
if { [lsearch [interp hidden] scoutSetPosDevFormatOutput] >= 0 } {
    interp expose {} scoutSetPosDevFormatOutput
}

proc ::scoutSetPosDev { name args } {
    set format {}
    for {set loop1(0) 0} { $loop1(0)<6 } { incr loop1(0)} {
    lappend format [list double "odoError.var\[$loop1(0)\]" 0.0 ]
}

    return [ ::cs::rqstSend "${name}" "SetPosDev" \
	"** undocumented **" \
	"SCOUT_ODO_VAR_STR\n| double var\[6\]\n" \
	6 \
	$format \
	$args ]
}


proc ::scoutSetPosDevFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSetPosDev
interp hide {} scoutSetPosDevFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] scoutStop] >= 0 } {
    interp expose {} scoutStop
}
if { [lsearch [interp hidden] scoutStopFormatOutput] >= 0 } {
    interp expose {} scoutStopFormatOutput
}

proc ::scoutStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::scoutStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutStop
interp hide {} scoutStopFormatOutput





# Turn ----------------------------------------------------------

if { [lsearch [interp hidden] scoutTurn] >= 0 } {
    interp expose {} scoutTurn
}
if { [lsearch [interp hidden] scoutTurnFormatOutput] >= 0 } {
    interp expose {} scoutTurnFormatOutput
}

proc ::scoutTurn { name args } {
    set format {}
    lappend format [list double "turn.dl" 0.0 ]
    lappend format [list double "turn.dth" 0.0 ]
    lappend format [list int "turn.speedPercent" 0 ]
    lappend format [list int "turn.unused" 0 ]

    return [ ::cs::rqstSend "${name}" "Turn" \
	"** undocumented **" \
	"SCOUT_TURN\n| double dl\n| double dth\n| int speedPercent\n| int unused\n" \
	4 \
	$format \
	$args ]
}


proc ::scoutTurnFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutTurn
interp hide {} scoutTurnFormatOutput





# GoTo ----------------------------------------------------------

if { [lsearch [interp hidden] scoutGoTo] >= 0 } {
    interp expose {} scoutGoTo
}
if { [lsearch [interp hidden] scoutGoToFormatOutput] >= 0 } {
    interp expose {} scoutGoToFormatOutput
}

proc ::scoutGoTo { name args } {
    set format {}
    lappend format [list { "SCOUT_BACKWARD_MOTION" "SCOUT_FORWARD_MOTION" } "ref.backFlag" "" ]
    lappend format [list int "ref.numRef" 0 ]
    lappend format [list double "ref.x" 0.0 ]
    lappend format [list double "ref.y" 0.0 ]
    lappend format [list double "ref.theta" 0.0 ]
    lappend format [list double "ref.v" 0.0 ]
    lappend format [list double "ref.w" 0.0 ]
    lappend format [list double "ref.vmax" 0.0 ]
    lappend format [list double "ref.wmax" 0.0 ]
    lappend format [list double "ref.linAccelMax" 0.0 ]
    lappend format [list double "ref.angAccelMax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "GoTo" \
	"** undocumented **" \
	"SCOUT_REF_STR\n| SCOUT_MOTION_DIRECTION backFlag\n| int numRef\n| double x\n| double y\n| double theta\n| double v\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	11 \
	$format \
	$args ]
}


proc ::scoutGoToFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutGoTo
interp hide {} scoutGoToFormatOutput





# GoToSpeed ----------------------------------------------------------

if { [lsearch [interp hidden] scoutGoToSpeed] >= 0 } {
    interp expose {} scoutGoToSpeed
}
if { [lsearch [interp hidden] scoutGoToSpeedFormatOutput] >= 0 } {
    interp expose {} scoutGoToSpeedFormatOutput
}

proc ::scoutGoToSpeed { name args } {
    set format {}
    lappend format [list int "speedRef.numRef" 0 ]
    lappend format [list int "speedRef.updatePeriod" 0 ]
    lappend format [list double "speedRef.v" 0.0 ]
    lappend format [list double "speedRef.w" 0.0 ]
    lappend format [list double "speedRef.vmax" 0.0 ]
    lappend format [list double "speedRef.wmax" 0.0 ]
    lappend format [list double "speedRef.linAccelMax" 0.0 ]
    lappend format [list double "speedRef.angAccelMax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "GoToSpeed" \
	"** undocumented **" \
	"SCOUT_SPEED_REF_STR\n| int numRef\n| int updatePeriod\n| double v\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	8 \
	$format \
	$args ]
}


proc ::scoutGoToSpeedFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutGoToSpeed
interp hide {} scoutGoToSpeedFormatOutput





# TrackStart ----------------------------------------------------------

if { [lsearch [interp hidden] scoutTrackStart] >= 0 } {
    interp expose {} scoutTrackStart
}
if { [lsearch [interp hidden] scoutTrackStartFormatOutput] >= 0 } {
    interp expose {} scoutTrackStartFormatOutput
}

proc ::scoutTrackStart { name args } {
    set format {}
    lappend format [list string "posterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "TrackStart" \
	"** undocumented **" \
	"SCOUT_POSTER_NAME\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::scoutTrackStartFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutTrackStart
interp hide {} scoutTrackStartFormatOutput





# TrackSpeedStart ----------------------------------------------------------

if { [lsearch [interp hidden] scoutTrackSpeedStart] >= 0 } {
    interp expose {} scoutTrackSpeedStart
}
if { [lsearch [interp hidden] scoutTrackSpeedStartFormatOutput] >= 0 } {
    interp expose {} scoutTrackSpeedStartFormatOutput
}

proc ::scoutTrackSpeedStart { name args } {
    set format {}
    lappend format [list string "posterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "TrackSpeedStart" \
	"** undocumented **" \
	"SCOUT_POSTER_NAME\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::scoutTrackSpeedStartFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutTrackSpeedStart
interp hide {} scoutTrackSpeedStartFormatOutput





# TrackConfigStart ----------------------------------------------------------

if { [lsearch [interp hidden] scoutTrackConfigStart] >= 0 } {
    interp expose {} scoutTrackConfigStart
}
if { [lsearch [interp hidden] scoutTrackConfigStartFormatOutput] >= 0 } {
    interp expose {} scoutTrackConfigStartFormatOutput
}

proc ::scoutTrackConfigStart { name args } {
    set format {}
    lappend format [list string "posterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "TrackConfigStart" \
	"** undocumented **" \
	"SCOUT_POSTER_NAME\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::scoutTrackConfigStartFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutTrackConfigStart
interp hide {} scoutTrackConfigStartFormatOutput





# TrackEnd ----------------------------------------------------------

if { [lsearch [interp hidden] scoutTrackEnd] >= 0 } {
    interp expose {} scoutTrackEnd
}
if { [lsearch [interp hidden] scoutTrackEndFormatOutput] >= 0 } {
    interp expose {} scoutTrackEndFormatOutput
}

proc ::scoutTrackEnd { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "TrackEnd" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::scoutTrackEndFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutTrackEnd
interp hide {} scoutTrackEndFormatOutput





# SonarsOn ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSonarsOn] >= 0 } {
    interp expose {} scoutSonarsOn
}
if { [lsearch [interp hidden] scoutSonarsOnFormatOutput] >= 0 } {
    interp expose {} scoutSonarsOnFormatOutput
}

proc ::scoutSonarsOn { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "SonarsOn" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::scoutSonarsOnFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSonarsOn
interp hide {} scoutSonarsOnFormatOutput





# SonarsOff ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSonarsOff] >= 0 } {
    interp expose {} scoutSonarsOff
}
if { [lsearch [interp hidden] scoutSonarsOffFormatOutput] >= 0 } {
    interp expose {} scoutSonarsOffFormatOutput
}

proc ::scoutSonarsOff { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "SonarsOff" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::scoutSonarsOffFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSonarsOff
interp hide {} scoutSonarsOffFormatOutput





# SetSonarsFiringOrder ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSetSonarsFiringOrder] >= 0 } {
    interp expose {} scoutSetSonarsFiringOrder
}
if { [lsearch [interp hidden] scoutSetSonarsFiringOrderFormatOutput] >= 0 } {
    interp expose {} scoutSetSonarsFiringOrderFormatOutput
}

proc ::scoutSetSonarsFiringOrder { name args } {
    set format {}
    lappend format [list int "sonarsFiring.fireRate" 0 ]
    lappend format [list int "sonarsFiring.unused" 0 ]
    for {set loop1(0) 0} { $loop1(0)<16 } { incr loop1(0)} {
    lappend format [list int "sonarsFiring.firedSonars\[$loop1(0)\]" 0 ]
}

    return [ ::cs::rqstSend "${name}" "SetSonarsFiringOrder" \
	"** undocumented **" \
	"SCOUT_SONARS_FIRING_ORDER\n| int fireRate\n| int unused\n| int firedSonars\[16\]\n" \
	18 \
	$format \
	$args ]
}


proc ::scoutSetSonarsFiringOrderFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSetSonarsFiringOrder
interp hide {} scoutSetSonarsFiringOrderFormatOutput





# GetSonarsFiringOrder ----------------------------------------------------------

if { [lsearch [interp hidden] scoutGetSonarsFiringOrder] >= 0 } {
    interp expose {} scoutGetSonarsFiringOrder
}
if { [lsearch [interp hidden] scoutGetSonarsFiringOrderFormatOutput] >= 0 } {
    interp expose {} scoutGetSonarsFiringOrderFormatOutput
}

proc ::scoutGetSonarsFiringOrder { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetSonarsFiringOrder" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::scoutGetSonarsFiringOrderFormatOutput { list } {
    set format { {} status { } { sonarsFiring { } fireRate { } unused { 16 } firedSonars } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutGetSonarsFiringOrder
interp hide {} scoutGetSonarsFiringOrderFormatOutput





# SetCmdDist ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSetCmdDist] >= 0 } {
    interp expose {} scoutSetCmdDist
}
if { [lsearch [interp hidden] scoutSetCmdDistFormatOutput] >= 0 } {
    interp expose {} scoutSetCmdDistFormatOutput
}

proc ::scoutSetCmdDist { name args } {
    set format {}
    lappend format [list double "distPoint" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetCmdDist" \
	"** undocumented **" \
	"double distPoint\n" \
	1 \
	$format \
	$args ]
}


proc ::scoutSetCmdDistFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSetCmdDist
interp hide {} scoutSetCmdDistFormatOutput





# GetCmdDist ----------------------------------------------------------

if { [lsearch [interp hidden] scoutGetCmdDist] >= 0 } {
    interp expose {} scoutGetCmdDist
}
if { [lsearch [interp hidden] scoutGetCmdDistFormatOutput] >= 0 } {
    interp expose {} scoutGetCmdDistFormatOutput
}

proc ::scoutGetCmdDist { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetCmdDist" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::scoutGetCmdDistFormatOutput { list } {
    set format { {} status { } distPoint }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutGetCmdDist
interp hide {} scoutGetCmdDistFormatOutput





# GetCmdConfig ----------------------------------------------------------

if { [lsearch [interp hidden] scoutGetCmdConfig] >= 0 } {
    interp expose {} scoutGetCmdConfig
}
if { [lsearch [interp hidden] scoutGetCmdConfigFormatOutput] >= 0 } {
    interp expose {} scoutGetCmdConfigFormatOutput
}

proc ::scoutGetCmdConfig { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetCmdConfig" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::scoutGetCmdConfigFormatOutput { list } {
    set format { {} status { } { cmd { } distPoint { } KpLongit { } KiLongit { } KpTransv { } KiTransv { } KpAng { } KiAng { } longitErrorMax { } transvErrorMax { } angErrorMax { } longitMaxErrSum { } transvMaxErrSum { } angMaxErrSum } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutGetCmdConfig
interp hide {} scoutGetCmdConfigFormatOutput





# SetCmdConfig ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSetCmdConfig] >= 0 } {
    interp expose {} scoutSetCmdConfig
}
if { [lsearch [interp hidden] scoutSetCmdConfigFormatOutput] >= 0 } {
    interp expose {} scoutSetCmdConfigFormatOutput
}

proc ::scoutSetCmdConfig { name args } {
    set format {}
    lappend format [list double "cmd.distPoint" 0.0 ]
    lappend format [list double "cmd.KpLongit" 0.0 ]
    lappend format [list double "cmd.KiLongit" 0.0 ]
    lappend format [list double "cmd.KpTransv" 0.0 ]
    lappend format [list double "cmd.KiTransv" 0.0 ]
    lappend format [list double "cmd.KpAng" 0.0 ]
    lappend format [list double "cmd.KiAng" 0.0 ]
    lappend format [list double "cmd.longitErrorMax" 0.0 ]
    lappend format [list double "cmd.transvErrorMax" 0.0 ]
    lappend format [list double "cmd.angErrorMax" 0.0 ]
    lappend format [list double "cmd.longitMaxErrSum" 0.0 ]
    lappend format [list double "cmd.transvMaxErrSum" 0.0 ]
    lappend format [list double "cmd.angMaxErrSum" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetCmdConfig" \
	"** undocumented **" \
	"SCOUT_CMD_PARAM_STR\n| double distPoint\n| double KpLongit\n| double KiLongit\n| double KpTransv\n| double KiTransv\n| double KpAng\n| double KiAng\n| double longitErrorMax\n| double transvErrorMax\n| double angErrorMax\n| double longitMaxErrSum\n| double transvMaxErrSum\n| double angMaxErrSum\n" \
	13 \
	$format \
	$args ]
}


proc ::scoutSetCmdConfigFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSetCmdConfig
interp hide {} scoutSetCmdConfigFormatOutput





# RobotPosition ----------------------------------------------------------

if { [lsearch [interp hidden] scoutRobotPositionPosterRead] >= 0 } {
    interp expose {} scoutRobotPositionPosterRead
}
if { [lsearch [interp hidden] scoutRobotPositionPosterFormatOutput] >= 0 } {
    interp expose {} scoutRobotPositionPosterFormatOutput
}

proc ::scoutRobotPositionPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RobotPosition" \
	"SCOUT_POS_STR\n| double x\n| double y\n| double xC\n| double yC\n| double theta\n| double v\n| double w\n" \
	$args ]
}


proc ::scoutRobotPositionPosterFormatOutput { list } {
    set format { {} status { } { Position { } x { } y { } xC { } yC { } theta { } v { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutRobotPositionPosterRead
interp hide {} scoutRobotPositionPosterFormatOutput





# RobotPosError ----------------------------------------------------------

if { [lsearch [interp hidden] scoutRobotPosErrorPosterRead] >= 0 } {
    interp expose {} scoutRobotPosErrorPosterRead
}
if { [lsearch [interp hidden] scoutRobotPosErrorPosterFormatOutput] >= 0 } {
    interp expose {} scoutRobotPosErrorPosterFormatOutput
}

proc ::scoutRobotPosErrorPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RobotPosError" \
	"SCOUT_ODO_VAR_STR\n| double var\[6\]\n" \
	$args ]
}


proc ::scoutRobotPosErrorPosterFormatOutput { list } {
    set format { {} status { } { PosError { 6 } var } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutRobotPosErrorPosterRead
interp hide {} scoutRobotPosErrorPosterFormatOutput





# Bumperbumper ----------------------------------------------------------

if { [lsearch [interp hidden] scoutBumperbumperPosterRead] >= 0 } {
    interp expose {} scoutBumperbumperPosterRead
}
if { [lsearch [interp hidden] scoutBumperbumperPosterFormatOutput] >= 0 } {
    interp expose {} scoutBumperbumperPosterFormatOutput
}

proc ::scoutBumperbumperPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Bumperbumper" \
	"SCOUT_BUMBERS_STATE\n| SCOUT_BOOL bumper\[6\]\n" \
	$args ]
}


proc ::scoutBumperbumperPosterFormatOutput { list } {
    set format { {} status { } { bumper { 6 } bumper } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutBumperbumperPosterRead
interp hide {} scoutBumperbumperPosterFormatOutput





# SonarssonarsEcho ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSonarssonarsEchoPosterRead] >= 0 } {
    interp expose {} scoutSonarssonarsEchoPosterRead
}
if { [lsearch [interp hidden] scoutSonarssonarsEchoPosterFormatOutput] >= 0 } {
    interp expose {} scoutSonarssonarsEchoPosterFormatOutput
}

proc ::scoutSonarssonarsEchoPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SonarssonarsEcho" \
	"SCOUT_SONARS_ECHO_RHO\n| double rho\[16\]\n" \
	$args ]
}


proc ::scoutSonarssonarsEchoPosterFormatOutput { list } {
    set format { {} status { } { sonarsEcho { 16 } rho } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSonarssonarsEchoPosterRead
interp hide {} scoutSonarssonarsEchoPosterFormatOutput





# SonarssonarsEchoFrameRobot ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSonarssonarsEchoFrameRobotPosterRead] >= 0 } {
    interp expose {} scoutSonarssonarsEchoFrameRobotPosterRead
}
if { [lsearch [interp hidden] scoutSonarssonarsEchoFrameRobotPosterFormatOutput] >= 0 } {
    interp expose {} scoutSonarssonarsEchoFrameRobotPosterFormatOutput
}

proc ::scoutSonarssonarsEchoFrameRobotPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SonarssonarsEchoFrameRobot" \
	"SCOUT_SONARS_ECHO_XY\n| SCOUT_POS\n| | double x\n| | double y\n" \
	$args ]
}


proc ::scoutSonarssonarsEchoFrameRobotPosterFormatOutput { list } {
    set format { {} status { } { sonarsEchoFrameRobot { 16 } { point { } x { } y } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSonarssonarsEchoFrameRobotPosterRead
interp hide {} scoutSonarssonarsEchoFrameRobotPosterFormatOutput





# SonarssonarsEchoFrameGlobal ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSonarssonarsEchoFrameGlobalPosterRead] >= 0 } {
    interp expose {} scoutSonarssonarsEchoFrameGlobalPosterRead
}
if { [lsearch [interp hidden] scoutSonarssonarsEchoFrameGlobalPosterFormatOutput] >= 0 } {
    interp expose {} scoutSonarssonarsEchoFrameGlobalPosterFormatOutput
}

proc ::scoutSonarssonarsEchoFrameGlobalPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SonarssonarsEchoFrameGlobal" \
	"SCOUT_SONARS_ECHO_XY\n| SCOUT_POS\n| | double x\n| | double y\n" \
	$args ]
}


proc ::scoutSonarssonarsEchoFrameGlobalPosterFormatOutput { list } {
    set format { {} status { } { sonarsEchoFrameGlobal { 16 } { point { } x { } y } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSonarssonarsEchoFrameGlobalPosterRead
interp hide {} scoutSonarssonarsEchoFrameGlobalPosterFormatOutput





# SensorsConfigsonarsCoord ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSensorsConfigsonarsCoordPosterRead] >= 0 } {
    interp expose {} scoutSensorsConfigsonarsCoordPosterRead
}
if { [lsearch [interp hidden] scoutSensorsConfigsonarsCoordPosterFormatOutput] >= 0 } {
    interp expose {} scoutSensorsConfigsonarsCoordPosterFormatOutput
}

proc ::scoutSensorsConfigsonarsCoordPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SensorsConfigsonarsCoord" \
	"SCOUT_SONARS_CONFIG\n| SCOUT_CONFIG\n| | double x\n| | double y\n| | double theta\n" \
	$args ]
}


proc ::scoutSensorsConfigsonarsCoordPosterFormatOutput { list } {
    set format { {} status { } { sonarsCoord { 16 } { sonarConfig { } x { } y { } theta } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSensorsConfigsonarsCoordPosterRead
interp hide {} scoutSensorsConfigsonarsCoordPosterFormatOutput





# SensorsConfigbumpersPos ----------------------------------------------------------

if { [lsearch [interp hidden] scoutSensorsConfigbumpersPosPosterRead] >= 0 } {
    interp expose {} scoutSensorsConfigbumpersPosPosterRead
}
if { [lsearch [interp hidden] scoutSensorsConfigbumpersPosPosterFormatOutput] >= 0 } {
    interp expose {} scoutSensorsConfigbumpersPosPosterFormatOutput
}

proc ::scoutSensorsConfigbumpersPosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SensorsConfigbumpersPos" \
	"SCOUT_BUMPERS_POS\n| SCOUT_POS\n| | double x\n| | double y\n" \
	$args ]
}


proc ::scoutSensorsConfigbumpersPosPosterFormatOutput { list } {
    set format { {} status { } { bumpersPos { 6 } { bumperPos { } x { } y } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutSensorsConfigbumpersPosPosterRead
interp hide {} scoutSensorsConfigbumpersPosPosterFormatOutput





# Referencesref ----------------------------------------------------------

if { [lsearch [interp hidden] scoutReferencesrefPosterRead] >= 0 } {
    interp expose {} scoutReferencesrefPosterRead
}
if { [lsearch [interp hidden] scoutReferencesrefPosterFormatOutput] >= 0 } {
    interp expose {} scoutReferencesrefPosterFormatOutput
}

proc ::scoutReferencesrefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Referencesref" \
	"SCOUT_REF_STR\n| SCOUT_MOTION_DIRECTION backFlag\n| int numRef\n| double x\n| double y\n| double theta\n| double v\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::scoutReferencesrefPosterFormatOutput { list } {
    set format { {} status { } { ref { } backFlag { } numRef { } x { } y { } theta { } v { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutReferencesrefPosterRead
interp hide {} scoutReferencesrefPosterFormatOutput





# ReferencesspeedRef ----------------------------------------------------------

if { [lsearch [interp hidden] scoutReferencesspeedRefPosterRead] >= 0 } {
    interp expose {} scoutReferencesspeedRefPosterRead
}
if { [lsearch [interp hidden] scoutReferencesspeedRefPosterFormatOutput] >= 0 } {
    interp expose {} scoutReferencesspeedRefPosterFormatOutput
}

proc ::scoutReferencesspeedRefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "ReferencesspeedRef" \
	"SCOUT_SPEED_REF_STR\n| int numRef\n| int updatePeriod\n| double v\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::scoutReferencesspeedRefPosterFormatOutput { list } {
    set format { {} status { } { speedRef { } numRef { } updatePeriod { } v { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutReferencesspeedRefPosterRead
interp hide {} scoutReferencesspeedRefPosterFormatOutput





# Statealarm ----------------------------------------------------------

if { [lsearch [interp hidden] scoutStatealarmPosterRead] >= 0 } {
    interp expose {} scoutStatealarmPosterRead
}
if { [lsearch [interp hidden] scoutStatealarmPosterFormatOutput] >= 0 } {
    interp expose {} scoutStatealarmPosterFormatOutput
}

proc ::scoutStatealarmPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Statealarm" \
	"SCOUT_ALARMS\n| int nbAlarms\n| int chocFlag\n| int lowBatteryFlag\n| int joystickInUseFlag\n| int estopDownFlag\n| int motionErrorFlag\n| int noMotionFlag\n| int importantDriftFlag\n| int refNotUpdatedFlag\n" \
	$args ]
}


proc ::scoutStatealarmPosterFormatOutput { list } {
    set format { {} status { } { alarm { } nbAlarms { } chocFlag { } lowBatteryFlag { } joystickInUseFlag { } estopDownFlag { } motionErrorFlag { } noMotionFlag { } importantDriftFlag { } refNotUpdatedFlag } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutStatealarmPosterRead
interp hide {} scoutStatealarmPosterFormatOutput





# Statebatteries ----------------------------------------------------------

if { [lsearch [interp hidden] scoutStatebatteriesPosterRead] >= 0 } {
    interp expose {} scoutStatebatteriesPosterRead
}
if { [lsearch [interp hidden] scoutStatebatteriesPosterFormatOutput] >= 0 } {
    interp expose {} scoutStatebatteriesPosterFormatOutput
}

proc ::scoutStatebatteriesPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Statebatteries" \
	"SCOUT_BATTERIES_STR\n| SCOUT_BATTERY_STATE charge\n| int unused\n| double levelCpu\n| double levelMotor\n" \
	$args ]
}


proc ::scoutStatebatteriesPosterFormatOutput { list } {
    set format { {} status { } { batteries { } charge { } unused { } levelCpu { } levelMotor } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} scoutStatebatteriesPosterRead
interp hide {} scoutStatebatteriesPosterFormatOutput


